<template>
	<v-container>
		<v-snackbar v-model="snackSucc" top :timeout="timeout" color="#72a051">Documento aprobado</v-snackbar>
		<v-snackbar v-model="snackRej" top :timeout="timeout" color="#c51f2f">Documento rechazado</v-snackbar>
		<v-snackbar v-model="snackEmail" top :timeout="timeout" color="orange">Email enviado</v-snackbar>
		<v-snackbar v-model="snackCustomMessage" top :timeout="timeout" color="blue">Mensaje enviado</v-snackbar>
		<p class="text-center display-1">Documentos de {{name}}</p>

		<v-form>
			<!-- Talento y nuevo ingreso -->
			<v-row
				v-if="typeScholarship === 'talento-especial' && lastScholarship !== penultimateScholarship"
			>
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataTalentNew" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" width="100%" height="300px"></iframe>
						</v-card-text>
						<v-card-actions>
							<v-row justify="space-around" justify-sm="center">
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonSucc ? true : false"
										:disabled="item.status === 'Aprobado' ? true : false"
										outlined
										block
										color="green"
										@click="acceptDocument(item)"
									>Aceptar</v-btn>
								</v-col>
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonRej ? true : false"
										:disabled="item.status === 'Rechazado' ? true : false"
										outlined
										block
										color="red"
										@click="rejectDocument(item)"
									>Rechazar</v-btn>
								</v-col>
							</v-row>
						</v-card-actions>
					</v-card>
				</v-col>
				<v-col cols="12" sm="6" md="4">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandImage">
							<v-card-text>
								<p class="text-center white--text title">{{dataImageTalent.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{dataImageTalent.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<img :src="image" width="100%" height="300px" />
						</v-card-text>
						<v-card-actions>
							<v-row justify="space-around" justify-sm="center">
								<v-col cols="12" sm="6">
									<v-btn
										:loading="loadButtonImageSucc"
										:disabled="dataImageTalent.status === 'Aprobado' ? true : false"
										outlined
										block
										color="green"
										@click="acceptPhoto(dataImageTalent)"
									>Aceptar</v-btn>
								</v-col>
								<v-col cols="12" sm="6">
									<v-btn
										:loading="loadButtonImageRej"
										:disabled="dataImageTalent.status === 'Rechazado' ? true : false"
										outlined
										block
										color="red"
										@click="rejectPhoto(dataImageTalent)"
									>Rechazar</v-btn>
								</v-col>
							</v-row>
						</v-card-actions>
					</v-card>
				</v-col>
			</v-row>
			<!-- Talento y renovación -->
			<v-row
				v-if="typeScholarship === 'talento-especial' && lastScholarship === penultimateScholarship"
			>
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataTalentRen" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" width="100%" height="300px"></iframe>
						</v-card-text>
						<v-card-actions>
							<v-row justify="space-around" justify-sm="center">
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonSucc ? true : false"
										:disabled="item.status === 'Aprobado' ? true : false"
										outlined
										block
										color="green"
										@click="acceptDocument(item)"
									>Aceptar</v-btn>
								</v-col>
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonRej ? true : false"
										:disabled="item.status === 'Rechazado' ? true : false"
										outlined
										block
										color="red"
										@click="rejectDocument(item)"
									>Rechazar</v-btn>
								</v-col>
							</v-row>
						</v-card-actions>
					</v-card>
				</v-col>
			</v-row>
			<!-- Normal y nuevo ingreso -->
			<v-row
				v-if="typeScholarship !== 'talento-especial' && lastScholarship !== penultimateScholarship"
			>
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataNew" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" width="100%" height="300px"></iframe>
						</v-card-text>
						<v-card-actions>
							<v-row justify="space-around" justify-sm="center">
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonSucc ? true : false"
										:disabled="item.status === 'Aprobado' ? true : false"
										outlined
										block
										color="green"
										@click="acceptDocument(item)"
									>Aceptar</v-btn>
								</v-col>
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonRej ? true : false"
										:disabled="item.status === 'Rechazado' ? true : false"
										outlined
										block
										color="red"
										@click="rejectDocument(item)"
									>Rechazar</v-btn>
								</v-col>
							</v-row>
						</v-card-actions>
					</v-card>
				</v-col>
				<v-col cols="12" sm="6" md="4">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandImage">
							<v-card-text>
								<p class="text-center white--text title">{{dataImageTalent.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{dataImage.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<img :src="image" width="100%" height="300px" />
						</v-card-text>
						<v-card-actions>
							<v-row justify="space-around" justify-sm="center">
								<v-col cols="12" sm="6">
									<v-btn
										:loading="loadButtonImageSucc"
										:disabled="dataImage.status === 'Aprobado' ? true : false"
										outlined
										block
										color="green"
										@click="acceptPhoto(dataImage)"
									>Aceptar</v-btn>
								</v-col>
								<v-col cols="12" sm="6">
									<v-btn
										:loading="loadButtonImageRej"
										:disabled="dataImage.status === 'Rechazado' ? true : false"
										outlined
										block
										color="red"
										@click="rejectPhoto(dataImage)"
									>Rechazar</v-btn>
								</v-col>
							</v-row>
						</v-card-actions>
					</v-card>
				</v-col>
			</v-row>
			<!-- Normal y renovación -->
			<v-row
				v-if="typeScholarship !== 'talento-especial' && lastScholarship === penultimateScholarship"
			>
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataRen" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" width="100%" height="300px"></iframe>
						</v-card-text>
						<v-card-actions>
							<v-row justify="space-around" justify-sm="center">
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonSucc ? true : false"
										:disabled="item.status === 'Aprobado' ? true : false"
										outlined
										block
										color="green"
										@click="acceptDocument(item)"
									>Aceptar</v-btn>
								</v-col>
								<v-col cols="12" sm="6">
									<v-btn
										:loading="index === loadButtonRej ? true : false"
										:disabled="item.status === 'Rechazado' ? true : false"
										outlined
										block
										color="red"
										@click="rejectDocument(item)"
									>Rechazar</v-btn>
								</v-col>
							</v-row>
						</v-card-actions>
					</v-card>
				</v-col>
			</v-row>
		</v-form>

		<!-- Botones para acciones -->
		<v-row justify="space-around">
			<v-col cols="12" sm="3">
				<v-btn :loading="loadButtonEmail" outlined block color="orange" @click="sendEmailWrongFiles">
					Enviar email
					<template v-slot:loader>
						<span>Enviando...</span>
					</template>
				</v-btn>
			</v-col>
			<v-col cols="12" sm="3">
				<v-btn outlined block color="pink" :to="{ name: 'MessagesStudent' }">Ver mensajes</v-btn>
			</v-col>
			<v-col cols="12" sm="3">
				<v-btn outlined block color="blue" @click="openCustomMessage">Crear mensaje</v-btn>
			</v-col>
			<v-col cols="12" sm="3">
				<v-btn
					:loading="buttonLoadingDocuments"
					outlined
					block
					color="indigo"
					@click="getZip"
				>Obtener documentos</v-btn>
			</v-col>
		</v-row>

		<ModalDocument :visible="modalDocument" :document="documentToModal" />
		<ModalImage :visible="modalImage" :image="image" />
		<FormCustomMessage :dialog="dialogMessage" />
	</v-container>
</template>

<script>
import gql from "graphql-tag";
import axios from "axios";
import ModalDocument from "@/components/admin/ModalDocument";
import ModalImage from "@/components/admin/ModalImage";
import FormCustomMessage from "@/components/admin/FormCustomMessage";
import EventBus from "../../bus";

export default {
	name: "Documents",
	components: { ModalDocument, ModalImage, FormCustomMessage },
	data: () => ({
		modalDocument: false,
		documentToModal: null,
		modalImage: false,
		name: "",
		dialogMessage: false,
		buttonLoadingDocuments: false,
		loadButtonEmail: false,
		loadButtonSucc: null,
		loadButtonRej: null,
		loadButtonImageSucc: null,
		loadButtonImageRej: null,
		timeout: 2000,
		snackSucc: false,
		snackRej: false,
		snackEmail: false,
		snackCustomMessage: false,
		lastScholarship: "",
		penultimateScholarship: "",
		typeScholarship: "",
		typeRequest: "",
		image: "",
		arrayTalentNew: [
			"birthAct",
			"ine",
			"curp",
			"reasonLetter",
			"curriculumVitae",
			"qualificationConstancy",
			"studyConstancy",
			"economicIncomes",
			"socioeconomicStudy",
			"acknowledgment"
		],
		arrayTalentRen: [
			"ine",
			"qualificationConstancy",
			"studyConstancy",
			"socialService",
			"socioeconomicStudy",
			"acknowledgment"
		],
		arrayNew: [
			"birthAct",
			"ine",
			"curp",
			"reasonLetter",
			"curriculumVitae",
			"qualificationConstancy",
			"studyConstancy",
			"economicIncomes",
			"socioeconomicStudy"
		],
		arrayRen: [
			"ine",
			"studyConstancy",
			"qualificationConstancy",
			"socioeconomicStudy",
			"socialService"
		],
		dataTalentNew: [
			{
				title: "Acta de nacimiento",
				desc: "Acta de nacimiento vigente.",
				file: "",
				field: "birthAct",
				index: 0,
				status: ""
			},
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				file: "",
				field: "ine",
				index: 1,
				status: ""
			},
			{
				title: "CURP",
				desc: "Clave Única de Registro de Población oficial.",
				file: "",
				field: "curp",
				index: 2,
				status: ""
			},
			{
				title: "Carta de exposición de motivos",
				desc:
					"Una carta que exponga los motivos para solicitar la beca.",
				file: "",
				field: "reasonLetter",
				index: 3,
				status: ""
			},
			{
				title: "Curriculum vitae",
				desc: "Documento con tu historial profesional.",
				file: "",
				field: "curriculumVitae",
				index: 4,
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				file: "",
				field: "qualificationConstancy",
				index: 5,
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				file: "",
				field: "studyConstancy",
				index: 6,
				status: ""
			},
			{
				title: "Comprobante de ingresos",
				desc: "Documento que avala los ingresos familiares.",
				file: "",
				field: "economicIncomes",
				index: 7,
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				file: "",
				field: "socioeconomicStudy",
				index: 8,
				status: ""
			},
			{
				title: "Premio nacional",
				desc: "Reconocimiento nacional vigente.",
				file: "",
				field: "acknowledgment",
				index: 9,
				status: ""
			}
		],
		dataImageTalent: {
			title: "Fotografía de la casa",
			desc: "Fotografía frontal de la casa.",
			file: "",
			field: "photoHouse",
			status: ""
		},
		dataTalentRen: [
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				file: "",
				field: "ine",
				index: 0,
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				file: "",
				field: "qualificationConstancy",
				index: 1,
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				file: "",
				field: "studyConstancy",
				index: 2,
				status: ""
			},
			{
				title: "Servicio social",
				desc: "Servicio social del semestre anterior.",
				file: "",
				field: "socialService",
				index: 3,
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				file: "",
				field: "socioeconomicStudy",
				index: 4,
				status: ""
			},
			{
				title: "Premio nacional",
				desc: "Reconocimiento nacional vigente.",
				file: "",
				field: "acknowledgment",
				index: 5,
				status: ""
			}
		],
		dataNew: [
			{
				title: "Acta de nacimiento",
				desc: "Acta de nacimiento vigente.",
				file: "",
				field: "birthAct",
				index: 0,
				status: ""
			},
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				file: "",
				field: "ine",
				index: 1,
				status: ""
			},
			{
				title: "CURP",
				desc: "Clave Única de Registro de Población oficial.",
				file: "",
				field: "curp",
				index: 2,
				status: ""
			},
			{
				title: "Carta de exposición de motivos",
				desc:
					"Una carta que exponga los motivos para solicitar la beca.",
				file: "",
				field: "reasonLetter",
				index: 3,
				status: ""
			},
			{
				title: "Curriculum vitae",
				desc: "Documento con tu historial profesional.",
				file: "",
				field: "curriculumVitae",
				index: 4,
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				file: "",
				field: "qualificationConstancy",
				index: 5,
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				file: "",
				field: "studyConstancy",
				index: 6,
				status: ""
			},
			{
				title: "Comprobante de ingresos",
				desc: "Documento que avala los ingresos familiares.",
				file: "",
				field: "economicIncomes",
				index: 7,
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				file: "",
				field: "socioeconomicStudy",
				index: 8,
				status: ""
			}
		],
		dataImage: {
			title: "Fotografía de la casa",
			desc: "Fotografía frontal de la casa.",
			file: "",
			field: "photoHouse",
			status: ""
		},
		dataRen: [
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				file: "",
				field: "ine",
				index: 0,
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				file: "",
				field: "studyConstancy",
				index: 1,
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				file: "",
				field: "qualificationConstancy",
				index: 2,
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				file: "",
				field: "socioeconomicStudy",
				index: 3,
				status: ""
			},
			{
				title: "Servicio social",
				desc: "Servicio social del semestre anterior.",
				file: "",
				field: "socialService",
				index: 4,
				status: ""
			}
		]
	}),
	methods: {
		// Obtiene el nombre del usuario
		async getName() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								personalData {
									name
									fstSurname
									sndSurname
								}
							}
						}
					`,
					variables: {
						curp: this.$route.params.student
					}
				});
				this.name = `${data.findStudent.personalData.name} ${data.findStudent.personalData.fstSurname} ${data.findStudent.personalData.sndSurname}`;
				EventBus.$emit("sendName", this.name);
			} catch (error) {}
		},
		// Obtiene las dos ultimas becas para condicionar el template
		async getScholarships() {
			try {
				const last = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							getLastScholarship(curp: $curp) {
								scholarship
							}
						}
					`,
					variables: {
						curp: this.$route.params.student
					}
				});

				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								scholarshipRecord {
									scholarship
								}
							}
						}
					`,
					variables: {
						curp: this.$route.params.student
					}
				});

				this.lastScholarship = last.data.getLastScholarship.scholarship;
				if (data.findStudent.scholarshipRecord.length > 1) {
					this.penultimateScholarship =
						data.findStudent.scholarshipRecord[1].scholarship;
				}

				this.getDocumentos();
			} catch (error) {}
		},
		// Obtiene los documentos
		async getDocumentos() {
			// if para talento y nuevo ingreso
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				this.saveFilesIntoObject(
					this.arrayTalentNew,
					this.dataTalentNew
				);
				this.getStatusOfDocuments(0);
				this.getImage();
			}
			// if para talento y renovación
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				this.saveFilesIntoObject(
					this.arrayTalentRen,
					this.dataTalentRen
				);
				this.getStatusOfDocuments(1);
			}
			// if para diferente de talento y nuevo ingreso
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				this.saveFilesIntoObject(this.arrayNew, this.dataNew);
				this.getStatusOfDocuments(2);
				this.getImage();
			}
			// if para diferente de talento y renovación
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				this.saveFilesIntoObject(this.arrayRen, this.dataRen);
				this.getStatusOfDocuments(3);
			}
		},
		// Obtiene los status de los documentos
		async getStatusOfDocuments(type) {
			try {
				switch (type) {
					case 0:
						const filesTalentNew = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											birthAct {
												status
											}
											ine {
												status
											}
											curp {
												status
											}
											reasonLetter {
												status
											}
											curriculumVitae {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											economicIncomes {
												status
											}
											socioeconomicStudy {
												status
											}
											photoHouse {
												status
											}
											acknowledgment {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.$route.params.student
							}
						});
						let arrayDocuments0 = [];
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents.birthAct
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents.ine
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents.curp
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.reasonLetter
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.curriculumVitae
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.studyConstancy
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.economicIncomes
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.socioeconomicStudy
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.acknowledgment
						);
						this.dataImageTalent.status =
							filesTalentNew.data.findStudent.documents.photoHouse.status;

						let contStatus0 = 0;
						for (let i of this.dataTalentNew) {
							i.status = arrayDocuments0[contStatus0].status;
							contStatus0++;
						}

						break;
					case 1:
						const filesTalentRen = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											ine {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											socialService {
												status
											}
											socioeconomicStudy {
												status
											}
											acknowledgment {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.$route.params.student
							}
						});
						let arrayDocuments1 = [];
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents.ine
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.studyConstancy
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.socialService
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.socioeconomicStudy
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.acknowledgment
						);
						let contStatus1 = 0;
						for (let i of this.dataTalentRen) {
							i.status = arrayDocuments1[contStatus1].status;
							contStatus1++;
						}
						break;
					case 2:
						const filesNew = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											birthAct {
												status
											}
											ine {
												status
											}
											curp {
												status
											}
											reasonLetter {
												status
											}
											curriculumVitae {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											economicIncomes {
												status
											}
											socioeconomicStudy {
												status
											}
											photoHouse {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.$route.params.student
							}
						});

						let arrayDocuments2 = [];
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.birthAct
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.ine
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.curp
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.reasonLetter
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.curriculumVitae
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.studyConstancy
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.economicIncomes
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.socioeconomicStudy
						);

						this.dataImage.status =
							filesNew.data.findStudent.documents.photoHouse.status;

						let contStatus2 = 0;
						for (let i of this.dataNew) {
							i.status = arrayDocuments2[contStatus2].status;
							contStatus2++;
						}
						break;
					case 3:
						const filesRen = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											ine {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											socioeconomicStudy {
												status
											}
											socialService {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.$route.params.student
							}
						});

						let arrayDocuments3 = [];
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.ine
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.studyConstancy
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents
								.socioeconomicStudy
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.socialService
						);
						let contStatus3 = 0;
						for (let i of this.dataRen) {
							i.status = arrayDocuments3[contStatus3].status;
							contStatus3++;
						}
						break;
				}
			} catch (error) {}
		},
		// guarda los archivos en el objeto correspondiente
		async saveFilesIntoObject(array, objectData) {
			try {
				let contFile = 0;
				for (let i of array) {
					let response = await axios.get(
						`/getFile/${this.$route.params.student}/${i}`,
						{
							responseType: "blob",
							headers: {
								Accept: "application/pdf",
								Authorization: sessionStorage.getItem("token")
							}
						}
					);
					objectData[contFile].file = window.URL.createObjectURL(
						new Blob([response.data], {
							type: "application/pdf"
						})
					);
					contFile++;
				}
			} catch (error) {}
		},
		// obtiene la imagen y la guarda en los campos files
		async getImage() {
			try {
				const response = await axios.get(
					`/getFile/${this.$route.params.student}/photoHouse`,
					{
						responseType: "arraybuffer",
						headers: {
							Authorization: sessionStorage.getItem("token")
						}
					}
				);

				const image = window.URL.createObjectURL(
					new Blob([response.data], {
						type: "image/jpeg"
					})
				);
				this.image = image;
			} catch (error) {}
		},
		// Acepta el documento
		async acceptDocument(document) {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$curp: String!
							$document: String!
							$status: String!
						) {
							checkDocument(
								curp: $curp
								document: $document
								status: $status
							)
						}
					`,
					variables: {
						curp: this.$route.params.student,
						document: document.field,
						status: "Aprobado"
					}
				});
				this.loadButtonSucc = document.index;
				setTimeout(() => {
					this.loadButtonSucc = null;
					this.snackSucc = true;
					this.getDocumentos();
				}, 2000);
			} catch (error) {}
		},
		// Rechaza el documento
		async rejectDocument(document) {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$curp: String!
							$document: String!
							$status: String!
						) {
							checkDocument(
								curp: $curp
								document: $document
								status: $status
							)
						}
					`,
					variables: {
						curp: this.$route.params.student,
						document: document.field,
						status: "Rechazado"
					}
				});

				this.loadButtonRej = document.index;
				setTimeout(() => {
					this.loadButtonRej = null;
					this.snackRej = true;
					this.getDocumentos();
				}, 2000);
			} catch (error) {}
		},
		// Acepta la foto
		async acceptPhoto(photo) {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$curp: String!
							$document: String!
							$status: String!
						) {
							checkDocument(
								curp: $curp
								document: $document
								status: $status
							)
						}
					`,
					variables: {
						curp: this.$route.params.student,
						document: photo.field,
						status: "Aprobado"
					}
				});

				this.loadButtonImageSucc = true;
				setTimeout(() => {
					this.loadButtonImageSucc = null;
					this.snackSucc = true;
					this.getDocumentos();
				}, 2000);
			} catch (error) {}
		},
		// Rechaza la foto
		async rejectPhoto(photo) {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation(
							$curp: String!
							$document: String!
							$status: String!
						) {
							checkDocument(
								curp: $curp
								document: $document
								status: $status
							)
						}
					`,
					variables: {
						curp: this.$route.params.student,
						document: photo.field,
						status: "Rechazado"
					}
				});

				this.loadButtonImageRej = true;
				setTimeout(() => {
					this.loadButtonImageRej = null;
					this.snackRej = true;
					this.getDocumentos();
				}, 2000);
			} catch (error) {}
		},
		// expande los documentos
		expandDocument(document) {
			this.documentToModal = document;
			this.modalDocument = true;
		},
		// expande las imagenes
		expandImage() {
			this.modalImage = true;
		},
		// Envia un correo con los archivos rechazados
		async sendEmailWrongFiles() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($curp: String!) {
							sendListOfWrongFiles(curp: $curp)
						}
					`,
					variables: {
						curp: this.$route.params.student
					}
				});
				this.loadButtonEmail = true;
				setTimeout(() => {
					this.snackEmail = true;
					this.loadButtonEmail = false;
				}, 2000);
			} catch (error) {}
		},
		// Muestra el modal para enviar el mensaje personalizado
		openCustomMessage() {
			this.dialogMessage = true;
		},
		// obtiene los documentos en un zip
		async getZip() {
			try {
				const response = await axios.get(
					`/getZip/${this.$route.params.student}`,
					{
						responseType: "arraybuffer",
						headers: {
							Authorization: sessionStorage.getItem("token")
						}
					}
				);
				this.buttonLoadingDocuments = true;
				setTimeout(() => {
					this.buttonLoadingDocuments = false;
					const url = window.URL.createObjectURL(
						new Blob([response.data])
					);
					const link = document.createElement("a");
					link.href = url;
					link.setAttribute(
						"download",
						`${this.name.replace(/ /g,"")}${this.$route.params.student}.zip`
					);
					document.body.appendChild(link);
					link.click();
				}, 2000);
			} catch (error) {}
		}
	},
	created() {
		this.typeScholarship = this.$route.params.typeScholarshipAdmin;
		this.getName();
		this.getScholarships();
	},
	mounted() {
		EventBus.$on("closeDocumentModal", () => {
			this.modalDocument = false;
		});

		EventBus.$on("closeImageModal", () => {
			this.modalImage = false;
		});

		EventBus.$on("closeFormCustomMessage", () => {
			this.dialogMessage = false;
		});

		EventBus.$on("succSendMessage", () => {
			this.snackCustomMessage = true;
		});
	}
};
</script>

